﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.IO;
using System.Xml;
using System.Data;
using ThinkGeo.MapSuite.WebEdition;
using ThinkGeo.MapSuite.Core;
using System.Reflection;
using OSPFM.Online.Framework;
using System.Collections.ObjectModel;
using System.Web.UI.HtmlControls;

namespace MS_OSPFM
{
    public partial class Alpha : System.Web.UI.Page
    {
        int iCurrentZoomLevel;
        TreeNode root = new TreeNode();
        TreeNode GrpLyr;
        TreeNode ChildLyr;
        MyTreeNode1.CustomTreeNode ctn;

        TreeNode ChildLyrElements;
        string sNodeGroupLayerName = string.Empty;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#B3C6D4"));
                Map1.CurrentExtent = new RectangleShape(-13939426.6371, 6701997.4056, -7812401.86, 2626987.386962);
                Map1.MapUnit = GeographyUnit.Meter;

                //Create 3 shapelayers (2 point and 1 line layer)
                ShapeFileFeatureLayer lyr_points_Access_Point = new ShapeFileFeatureLayer(MapPath("~/Data/Access_Points.shp"));
                lyr_points_Access_Point.ZoomLevelSet.ZoomLevel18.DefaultPointStyle = PointStyles.CreateSimplePointStyle(PointSymbolType.Circle, GeoColor.SimpleColors.Blue, 12f);
                lyr_points_Access_Point.ZoomLevelSet.ZoomLevel18.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                lyr_points_Access_Point.DrawingMarginPercentage = 50;
                lyr_points_Access_Point.IsVisible = true;

                //*******************  This is label layer mapping to same shape file as Access point
                ShapeFileFeatureLayer lbl_Access_Point = new ShapeFileFeatureLayer(MapPath("~/Data/Access_Points.shp"));
                lbl_Access_Point.ZoomLevelSet.ZoomLevel19.DefaultPointStyle = PointStyles.CreateSimplePointStyle(PointSymbolType.Circle, GeoColor.SimpleColors.Blue, 12f);
                lbl_Access_Point.ZoomLevelSet.ZoomLevel19.DefaultTextStyle = TextStyles.City1("Type_Name");
                lbl_Access_Point.ZoomLevelSet.ZoomLevel19.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                lbl_Access_Point.DrawingMarginPercentage = 50;
                lbl_Access_Point.IsVisible = true;

                ShapeFileFeatureLayer lyr_lines_FS_LD = new ShapeFileFeatureLayer(Server.MapPath("~/Data/FS_LD.shp"));
                lyr_lines_FS_LD.ZoomLevelSet.ZoomLevel05.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.StandardColors.Blue, 1.5f, true);
                lyr_lines_FS_LD.ZoomLevelSet.ZoomLevel05.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                lyr_lines_FS_LD.DrawingMarginPercentage = 50;
                lyr_lines_FS_LD.IsVisible = true;

                //Set projection for all 3 layers (2 point and 1 line layer)
                Proj4Projection proj4_points_Access_Points_lbl = new Proj4Projection();
                proj4_points_Access_Points_lbl.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
                proj4_points_Access_Points_lbl.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
                lbl_Access_Point.FeatureSource.Projection = proj4_points_Access_Points_lbl;

                Proj4Projection proj4_points_Access_Points = new Proj4Projection();
                proj4_points_Access_Points.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
                proj4_points_Access_Points.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
                lyr_points_Access_Point.FeatureSource.Projection = proj4_points_Access_Points;

                Proj4Projection proj4_lines_FS_LD = new Proj4Projection();
                proj4_lines_FS_LD.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
                proj4_lines_FS_LD.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
                lyr_lines_FS_LD.FeatureSource.Projection = proj4_lines_FS_LD;

                //Create in Memory layer to draw rectangle on map & projection for that
                InMemoryFeatureLayer shapeLayer = new InMemoryFeatureLayer();
                shapeLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.CreateSimpleCircleStyle(GeoColor.FromArgb(180, 102, 255, 102), 10, GeoColor.StandardColors.DarkGreen, 1);
                shapeLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.StandardColors.Green, 4, true);
                shapeLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromArgb(180, 102, 255, 102), GeoColor.StandardColors.DarkGreen, 1);
                shapeLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                shapeLayer.DrawingQuality = DrawingQuality.HighQuality;

                Proj4Projection proj4_shapeLayer = new Proj4Projection();
                proj4_shapeLayer.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
                proj4_shapeLayer.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
                shapeLayer.FeatureSource.Projection = proj4_shapeLayer;

                Proj4Projection proj4ForShapes = new Proj4Projection();
                proj4ForShapes.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
                proj4ForShapes.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
                proj4ForShapes.Open();
                //Map1.EditOverlay.FeatureSource.Projection = proj4ForShapes;

                //Create layer over lay and add above 4 layers to it
                LayerOverlay layerOverLay = new LayerOverlay("OSPFM Layers");
                layerOverLay.IsBaseOverlay = false;
                layerOverLay.ClientCache.CacheId = "OSPFM_Layers";
                layerOverLay.TransitionEffect = TransitionEffect.None;

                layerOverLay.Layers.Add("Lyr_Access_Point", lyr_points_Access_Point);
                layerOverLay.Layers.Add("Lbl_Access_Point", lbl_Access_Point);
                layerOverLay.Layers.Add("Lyr_FS_LD", lyr_lines_FS_LD);
                layerOverLay.Layers.Add("shapeLayer", shapeLayer);
                layerOverLay.TileType = TileType.SingleTile;

                //Create VE layer and to Map1
                VirtualEarthOverlay ve = new VirtualEarthOverlay("VirtualEarth Map");
                ve.VirtualEarthMapType = VirtualEarthMapType.Birdseye;

                Map1.CustomOverlays.Add(layerOverLay);
                Map1.CustomOverlays.Add(ve);
            }
            else
            {
            }
        }

        protected void Tabs_ActiveTabChanged(object sender, EventArgs e)
        {

        }

        protected void TreeView1_SelectedNodeChanged(object sender, EventArgs e)
        {
            RectangleShape rs = new RectangleShape(TreeView1.SelectedNode.Value);
            Map1.CurrentExtent = ExtentHelper.GetDrawingExtent(rs, (float)Map1.WidthInPixels, (float)Map1.HeightInPixels);

            LoadData();
        }

        void LoadData()
        {
            RectangleShape rectangle;
            panel.Controls.Clear();

            if (Map1.EditOverlay.Features.Count != 0)
            {
                rectangle = Map1.EditOverlay.Features[0].GetBoundingBox();
                //ViewState["rectangle"] = rectangle;
                //}
                //else
                //{
                //    rectangle = (RectangleShape)ViewState["rectangle"];
                //}

                ShapeFileFeatureLayer lineLayer = (ShapeFileFeatureLayer)((LayerOverlay)Map1.CustomOverlays[0]).Layers["Lyr_FS_LD"];
                ShapeFileFeatureLayer pointLayer = (ShapeFileFeatureLayer)((LayerOverlay)Map1.CustomOverlays[0]).Layers["Lyr_Access_Point"];
                InMemoryFeatureLayer recLayer = (InMemoryFeatureLayer)((LayerOverlay)Map1.CustomOverlays[0]).Layers["shapeLayer"];

                lineLayer.Open();
                pointLayer.Open();
                recLayer.Open();
                Collection<Feature> lineFeatures = lineLayer.QueryTools.GetFeaturesIntersecting(rectangle, ReturningColumnsType.AllColumns);
                Collection<Feature> pointFeatures = pointLayer.QueryTools.GetFeaturesIntersecting(rectangle, ReturningColumnsType.AllColumns);
                recLayer.InternalFeatures.Clear();
                recLayer.InternalFeatures.Add(new Feature(rectangle));

                lineLayer.Close();
                pointLayer.Close();
                recLayer.Close();

                AddList1(lineFeatures, "FiberSecurity");
                AddList1(pointFeatures, "AccessPoints");

                //ViewState["tv"] = TreeView1;
            }
            //Map1.EditOverlay.Features.Clear();
            //===============================
        }

        void AddList1(Collection<Feature> features, string sGroupLayerName)
        {
            if (features.Count != 0)
            {
                WellKnownType featureType = features[0].GetWellKnownType();
                string shapeTypeString = (featureType == WellKnownType.Point ? "Points" : "Lines");
                string colName = shapeTypeString == "Points" ? "Type_Name" : "Name";

                System.Web.UI.WebControls.Label label = new System.Web.UI.WebControls.Label();
                label.Text = shapeTypeString + "<br/>";
                label.Font.Size = 10;
                panel.Controls.Add(label);

                foreach (Feature feature in features)
                {
                    LiteralControl br = new LiteralControl("<br/>");
                    HtmlAnchor anchor = new HtmlAnchor();
                    anchor.InnerHtml = feature.ColumnValues[colName];
                    anchor.HRef = "#";
                    anchor.Attributes.Add("wkt", feature.GetWellKnownText());
                    anchor.Attributes.Add("onmouseover", "linkOver(this)");
                    anchor.Attributes.Add("onmouseout", "linkOut()");
                    // anchor.ServerClick+=new EventHandler(anchor_ServerClick);

                    panel.Controls.Add(anchor);
                    panel.Controls.Add(br);
                }
            }
            //=============================================
            sNodeGroupLayerName = sGroupLayerName + " (" + features.Count + ")";
            GrpLyr = new TreeNode(sNodeGroupLayerName);
            if (features.Count > 0)
            {
                for (int i = 0; i < features.Count; i++)
                {
                    if (sGroupLayerName == "FiberSecurity")
                    {
                        HtmlAnchor ha = new HtmlAnchor();
                        ctn = new MyTreeNode1.CustomTreeNode(features[i].ColumnValues["Name"] + " -", features[i].ColumnValues["Name"], features[i].GetWellKnownText());

                        ChildLyr = ctn;

                    }
                    else if (sGroupLayerName == "AccessPoints")
                    {
                        HtmlAnchor ha = new HtmlAnchor();
                        ctn = new MyTreeNode1.CustomTreeNode(features[i].ColumnValues["Type_Name"] + " -", features[i].ColumnValues["Type_Name"], features[i].GetWellKnownText());
                        ChildLyr = ctn;
                    }

                    GrpLyr.ChildNodes.Add(ChildLyr);

                    string[] aKeys = new string[features[i].ColumnValues.Keys.Count];

                    features[i].ColumnValues.Keys.CopyTo(aKeys, 0);

                    for (int j = 0; j < aKeys.Length; j++)
                    {
                        ChildLyrElements = new TreeNode();
                        ChildLyrElements.Text = aKeys[j].ToString() + ":" + features[i].ColumnValues[aKeys[j]];
                        ChildLyr.ChildNodes.Add(ChildLyrElements);
                    }
                }
            }

            root.ChildNodes.Add(GrpLyr);
            if (TreeView1.Nodes.Count == 0)
            {
                TreeView1.Nodes.Add(root);
            }
            //TreeView1.Nodes[0].ChildNodes[0].ExpandAll();
            TreeView1.Nodes[0].Expand();
        }

        protected void Map1_TrackShapeFinished(object sender, EventArgs e)
        {
            LoadData();
            //Map1.EditOverlay.Features.Clear();
        }
    }
}
